
// Created with Qt Design Studio (version 4.6.0), Wed Jun 19 10:26:51 2024
// Do not manually edit this file, it will be overwritten if effect is modified in Qt Design Studio.

import QtQuick

Item {
    id: rootItem

    // Use visible property to show and hide the effect.
    visible: true

    // This is an internal property used by tooling to identify effect items. Do not modify.
    property bool _isEffectItem

    // This is an internal property used to manage the effect. Do not modify.
    property Item _oldParent: null

    // This is the main source for the effect. Set internally to the current parent item. Do not modify.
    property Item source: null

    onParentChanged: {
        if (_oldParent && _oldParent !== parent) {
            _oldParent.layer.enabled = false
            _oldParent.layer.effect = null
            
            source = null
            _oldParent.update()
            _oldParent = null
        }
        if (parent) {
            _oldParent = parent
            if (visible) {
                parent.layer.enabled = true
                parent.layer.effect = effectComponent
            }
            
            source = parent
        }
    }

    onVisibleChanged: {
        if (visible) {
            parent.layer.enabled = true
            parent.layer.effect = effectComponent
            
            source = parent
        } else {
            parent.layer.enabled = false
            parent.layer.effect = null
            
            source = null
        }
        parent.update()
    }

    // Sets how tightly or loosely the swirls wrap around the center point.
    property real swirlWaveLength: 5.82
    // Sets the intensity of the swirl. This defines how far the graphics deviate from the center point.
    property real swirlAmplitude: 0.21
    // Sets the starting point of the swirl.
    property real swirlPhase: 0.4
    // Sets the point around which the swirl effect revolves. 0.5, 0.5 is the center.
    property point swirlCenterPoint: Qt.point(0.5, 0.5)

    Component {
        id: effectComponent
        ShaderEffect {
            property Item source: null
            readonly property Item iSource: rootItem.source
            readonly property vector3d iResolution: Qt.vector3d(width, height, 1.0)
            readonly property real swirlWaveLength: rootItem.swirlWaveLength
            readonly property real swirlAmplitude: rootItem.swirlAmplitude
            readonly property real swirlPhase: rootItem.swirlPhase
            readonly property point swirlCenterPoint: rootItem.swirlCenterPoint

            vertexShader: 'swirleffect.vert.qsb'
            fragmentShader: 'swirleffect.frag.qsb'
            anchors.fill: rootItem.source
            mesh: GridMesh {
                resolution: Qt.size(100, 100)
            }
        }
    }
}
